/etc/init.d/arc-datadelivery-service is in nordugrid-arc-datadelivery-service 5.4.2-1build1.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 | #!/bin/bash
#
# Init file for the DataDelivery service
#
# chkconfig: 2345 87 13
# description: ARC DataDelivery service
# processname: arched
### BEGIN INIT INFO
# Provides: arc-datadelivery-service
# Required-Start: $local_fs $remote_fs
# Required-Stop: $local_fs $remote_fs
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: ARC DataDelivery service
# Description: ARC DataDelivery service
### END INIT INFO
# source function library
if [ -f /etc/init.d/functions ]; then
. /etc/init.d/functions
log_success_msg() {
echo -n "$@"
success "$@"
echo
}
log_warning_msg() {
echo -n "$@"
warning "$@"
echo
}
log_failure_msg() {
echo -n "$@"
failure "$@"
echo
}
elif [ -f /lib/lsb/init-functions ]; then
. /lib/lsb/init-functions
else
echo "Error: Cannot source neither init.d nor lsb functions"
exit 1
fi
add_library_path() {
location="$1"
if [ ! "x$location" = "x" ] ; then
if [ ! "$location" = "/usr" ] ; then
libdir="$location/lib"
libdir64="$location/lib64"
if [ -d "$libdir64" ] ; then
if [ "x$LD_LIBRARY_PATH" = "x" ]; then
LD_LIBRARY_PATH="$libdir64"
else
LD_LIBRARY_PATH="$libdir64:$LD_LIBRARY_PATH"
fi
fi
if [ -d "$libdir" ] ; then
if [ "x$LD_LIBRARY_PATH" = "x" ]; then
LD_LIBRARY_PATH="$libdir"
else
LD_LIBRARY_PATH="$libdir:$LD_LIBRARY_PATH"
fi
fi
fi
fi
}
prog=arched
RUN=yes
# sysconfig files
if [ -r /etc/sysconfig/nordugrid ]; then
. /etc/sysconfig/nordugrid
elif [ -r /etc/default/nordugrid ]; then
. /etc/default/nordugrid
fi
if [ -r /etc/sysconfig/arc-datadelivery-service ]; then
. /etc/sysconfig/arc-datadelivery-service
elif [ -r /etc/default/arc-datadelivery-service ]; then
. /etc/default/arc-datadelivery-service
fi
# GLOBUS_LOCATION
GLOBUS_LOCATION=${GLOBUS_LOCATION:-/usr}
if [ ! -d "$GLOBUS_LOCATION" ]; then
log_failure_msg "GLOBUS_LOCATION ($GLOBUS_LOCATION) not found"
exit 1
fi
export GLOBUS_LOCATION
# ARC_LOCATION
ARC_LOCATION=${ARC_LOCATION:-/usr}
if [ ! -d "$ARC_LOCATION" ]; then
log_failure_msg "ARC_LOCATION ($ARC_LOCATION) not found"
exit 1
fi
export ARC_LOCATION
# Needed to get pid file
readconfigvar() {
fname=$1
if [ ! -r "$fname" ]; then
return
fi
bname="[$2]"
vname=$3
value=
cat "$fname" | grep -e '^\[' -e "^${vname}[[:space:]]*=" | {
while true; do
read line
if [ ! $? = 0 ] ; then
return
fi
if [ "$line" = "$bname" ] ; then
while true ; do
read line
if [ ! $? = 0 ] ; then
return
fi
lstart=`echo "$line" | head -c 1`
if [ "$lstart" = '[' ] ; then
return
fi
vlname=`echo "$line" | sed 's/=.*//;t;s/.*//'`
vlname=`eval "echo $vlname"`
if [ "$vlname" = "$vname" ] ; then
val=`echo "$line" | sed 's/[^=]*=//'`
eval "echo $val"
return
fi
done
fi
done
}
}
# ARC_CONFIG
if [ "x$ARC_CONFIG" = "x" ]; then
if [ -r $ARC_LOCATION/etc/arc.conf ]; then
ARC_CONFIG=$ARC_LOCATION/etc/arc.conf
elif [ -r /etc/arc.conf ]; then
ARC_CONFIG=/etc/arc.conf
fi
fi
PID_FILE=`readconfigvar "$ARC_CONFIG" common pidfile`
if [ `id -u` = 0 ] ; then
# Debian does not have /var/lock/subsys
if [ -d /var/lock/subsys ]; then
LOCKFILE=/var/lock/subsys/$prog-datadelivery-service
else
LOCKFILE=/var/lock/$prog-datadelivery-service
fi
if [ "x$PID_FILE" = "x" ]; then
PID_FILE=/var/run/$prog-datadelivery-service.pid
fi
else
LOCKFILE=$HOME/$prog-datadelivery-service.lock
if [ "x$PID_FILE" = "x" ]; then
PID_FILE=$HOME/$prog-datadelivery-service.pid
fi
fi
LOG_FILE=`readconfigvar "$ARC_CONFIG" common logfile`
if [ "x$LOG_FILE" = "x" ]; then
LOG_FILE=/var/log/arc/datadelivery-service.log
fi
prepare() {
CMD="$ARC_LOCATION/sbin/$prog"
if [ ! -x "$CMD" ]; then
log_failure_msg "Missing executable"
exit 1
fi
if [ ! -r "$ARC_CONFIG" ]; then
log_failure_msg "ARC configuration not found (usually /etc/arc.conf)"
exit 1
fi
# check that at least service is defined
grep -e '^\[datadelivery-service\]' $ARC_CONFIG 1>/dev/null 2>&1
if [ $? -ne 0 ] ; then
log_failure_msg "Data delivery service not defined in configuration"
exit 1
fi
# check that if service is insecure no allowed_dns are defined
SECURE=`readconfigvar "$ARC_CONFIG" common secure`
ALLOWEDDN=`readconfigvar "$ARC_CONFIG" datadelivery-service allowed_dn`
if [ "$SECURE" = "no" ]; then
if [ "x$ALLOWEDDN" != "x" ]; then
log_failure_msg "allowed_dn cannot be used with secure=no"
exit 1
fi
fi
# Assuming ini style config
CMD="$CMD -i '$ARC_CONFIG' -p '$PID_FILE' -l '$LOG_FILE'"
add_library_path "$GLOBUS_LOCATION"
if [ "x$LD_LIBRARY_PATH" = "x" ]; then
LD_LIBRARY_PATH=$ARC_LOCATION/lib
else
LD_LIBRARY_PATH=$ARC_LOCATION/lib:$LD_LIBRARY_PATH
fi
export LD_LIBRARY_PATH
cd /
}
start() {
if [ "$RUN" != "yes" ] ; then
echo "arc-datadelivery-service disabled, please adjust the configuration to your"
echo "needs and then set RUN to 'yes' in /etc/default/arc-datadelivery-service to"
echo "enable it."
return 0
fi
echo -n "Starting $prog: "
# Check if we are already running
if [ -f $PID_FILE ]; then
read pid < $PID_FILE
if [ "x$pid" != "x" ]; then
ps -p "$pid" -o comm 2>/dev/null | grep "^$prog$" 1>/dev/null 2>/dev/null
if [ $? -eq 0 ] ; then
log_success_msg "already running (pid $pid)"
return 0
fi
fi
rm -f "$PID_FILE" "$LOCKFILE"
fi
prepare
eval "$CMD"
RETVAL=$?
if [ $RETVAL -eq 0 ]; then
touch $LOCKFILE
log_success_msg
else
log_failure_msg
fi
return $RETVAL
}
stop() {
echo -n "Stopping $prog: "
if [ -f "$PID_FILE" ]; then
read pid < "$PID_FILE"
if [ ! -z "$pid" ] ; then
kill "$pid"
RETVAL=$?
if [ $RETVAL -eq 0 ]; then
log_success_msg
else
log_failure_msg
fi
timeout=10; # enough time to kill any active processes
while ( ps -p "$pid" -o comm 2>/dev/null | grep "^$prog$" 1>/dev/null 2>/dev/null ) && [ $timeout -ge 1 ] ; do
sleep 1
timeout=$(($timeout - 1))
done
[ $timeout -lt 1 ] && kill -9 "$pid" 1>/dev/null 2>&1
rm -f "$PID_FILE" "$LOCKFILE"
else
RETVAL=1
log_failure_msg "$prog shutdown - pidfile is empty"
fi
else
RETVAL=0
log_success_msg "$prog shutdown - already stopped"
fi
return $RETVAL
}
status() {
if [ -f "$PID_FILE" ]; then
read pid < "$PID_FILE"
if [ "$pid" != "" ]; then
if ps -p "$pid" > /dev/null; then
echo "$1 (pid $pid) is running..."
return 0
fi
echo "$1 stopped but pid file exists"
return 1
fi
fi
if [ -f $LOCKFILE ]; then
echo "$1 stopped but lockfile exists"
return 2
fi
echo "$1 is stopped"
return 3
}
restart() {
stop
start
}
case "$1" in
start)
start
;;
stop)
stop
;;
status)
status $prog
;;
restart | force-reload)
restart
;;
reload)
;;
condrestart | try-restart)
[ -f $LOCKFILE ] && restart || :
;;
*)
echo "Usage: $0 {start|stop|status|restart|force-reload|reload|condrestart|try-restart}"
exit 1
;;
esac
exit $?
|